/*
 * OpenEAS Experlog Application Server
 * Web application development and dynamic template scripting engine
 * Copyright (c) 2004 ExperLog SARL - http://www.experlog.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. You should have
 * received a copy of the GNU General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package org.experlog.db;

import java.sql.DriverManager;
import java.sql.SQLException;

public class DummyDriver implements java.sql.Driver {

    static {
        try {
            // register the driver with the JDBC DriverManager
            DriverManager.registerDriver(new org.experlog.db.DummyDriver());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public DummyDriver() {
    }

    /**
     *
     */
    public java.sql.Connection connect(String url, java.util.Properties info)
            throws SQLException {
        if (acceptsURL(url))
            return new DummyConnection();
        else
            return null; // May cause a "No suitable driver" exception
    }

    /**
     *
     */
    public boolean acceptsURL(String url) throws SQLException {
        return url.startsWith("jdbc:openeas");
    }

    public java.sql.DriverPropertyInfo[] getPropertyInfo(String url,
                                                         java.util.Properties info) throws SQLException {
        return null;
    }


    /**
     * Get the driver's major version number. Initially this should be 1.
     */
    public int getMajorVersion() {
        return 1;
    }

    /**
     * Get the driver's minor version number. Initially this should be 0.
     */
    public int getMinorVersion() {
        return 0;
    }


    /**
     */
    public boolean jdbcCompliant() {
        return false;
    }

}

;

