/*
 * OpenEAS Experlog Application Server
 * Web application development and dynamic template scripting engine
 * Copyright (c) 2004 ExperLog SARL - http://www.experlog.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version. This program is distributed in
 * the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. You should have
 * received a copy of the GNU General Public License along with this program;
 * if not, write to the Free Software Foundation, Inc.,
 * 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Created on 23 sept. 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.experlog.util;

import java.io.IOException;
import java.util.Hashtable;
import java.util.Locale;
import java.util.Properties;

import org.experlog.openeas.api.DataObject;

/**
 * @author spengler
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public interface Configuration extends DataObject {
	public static final int INT_DEFAULT = -32767;

	public abstract void parseProperties(Properties props);


		public abstract String getSqlEncodeSubst(String datasourcename) ;
		public abstract String getSqlEncodeSeparator(String datasourcename) ;
		public abstract Hashtable getDatasources() ;
		// JDBC configuration
		public abstract String getJdbcDriverClass() ;
		public abstract String getDataSourceName() ;
		public abstract String getJdbcUser() ;
		public abstract String getJdbcPassword() ;
		public abstract String getJdbcUrl() ;
		public abstract String getResultSet() ;
		public abstract int getMaxConn() ;
		public abstract int getMinConn() ;
		public abstract String getJdbcTestStmt() ;
		public abstract boolean isGC() ;
		public abstract int getCheckLevelObject() ;
		public abstract String getDriverClass() ;
		public abstract String getMbeanserver() ;
		public abstract String getDelegatefile() ;
		public abstract String getConffilename() ;
		public abstract void setJdbcDriverClass(String driverclass) ;
		public abstract void setDataSourceName(String datasourcename) ;
		public abstract void setJdbcUser(String user) ;
		public abstract void setJdbcPassword(String password) ;
		public abstract void setJdbcUrl(String jdbcurl) ;
		public abstract void setMaxConn(int maxconn) ;
		public abstract void setMinConn(int minconn) ;
		public abstract void setJdbcTestStmt(String jdbcteststmt) ;
		public abstract void setGC(boolean gc) ;
		public abstract void setCheckLevelObject(int checklevelobject) ;
		public abstract void setDriverClass(String driverclass) ;
		public abstract void setTimeout(int time) ;
		public abstract void setDelegatefile(String dfile) ;
		// Shop configuration
		public abstract String getName() ;
		/**
		* Get this shop's administrator password
		*/
		public abstract String getAdminPassword(String id);
		/**
		 * Get this shop's root directory (shop.RootDir property)
		 */
		public abstract String getRootDir();
		/**
		 * Get this shop's currency unit (shop.Currency property)
		 */
		public abstract String getCurrency();
		/**
		 * Get/set the Locale
		 */
		public abstract Locale getLocale();
		public abstract void setLocale(String lname);
		
		public abstract int getTimeout();
		public abstract boolean servletsOnly();
		public abstract String get(String pname) throws java.sql.SQLException;
		public abstract String get(String pname, String value)
			throws java.sql.SQLException;
		public abstract double getDouble(String pname) throws IOException;
		public abstract void setOfftmpl(String off) ;
		public abstract String getOfftmpl() ;
				
		public abstract String getUploadDir();
		public abstract int getJdbcTxIsolation();
		
		public abstract String getContentType(String atype);
}
